'use strict';

var OrcamentoAnaliticoLicitacaoController = angular.module('OrcamentoAnaliticoLicitacaoController', []);

OrcamentoAnaliticoLicitacaoController.controller('OrcamentoAnaliticoLicitacaoCtrl', ['$scope', '$filter', 'Relatorio', 'CacheApp',
  ($scope, $filter, Relatorio, CacheApp) => {

    $scope.getOrcamentoAnaliticoLicitacao = () => {
        $scope.planejado = {};
        Relatorio.getRelatorioOrcamentoAnaliticoLicitacao($scope.construcao.Id,
            (data) => {
                $scope.planejado = data.Instance;
                if (data.Instance)
                    $scope.construcao.ValorBDI = data.Instance.Valor;
                $scope.bases = '';
                for(var i in $scope.planejado.Bases)
                    $scope.bases += $scope.planejado.Bases[i] + '\r\n';
            });
    }

    $scope.pdfOrcamentoAnaliticoLicitacao = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda,
            Bases: $scope.bases,
            Bdi: $scope.bdi,
            Encargos: $scope.encargos
        };

        if ($scope.assinatura == true) {
            cabecalho.Responsavel = $scope.construcao.Contato
        };
        if ($scope.descricaoObra == true) {
            cabecalho.DescricaoObra = $scope.construcao.Descricao
        };

        Relatorio.pdfRelatorioOrcamentoAnaliticoLicitacao($scope.construcao.Id, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.xlsOrcamentoAnaliticoLicitacao = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda,
            Bases: $scope.bases,
            Bdi: $scope.bdi,
            Encargos: $scope.encargos
        };

        Relatorio.xlsRelatorioOrcamentoAnaliticoLicitacao($scope.construcao.Id, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
        });
    }

    $scope.loadPage = function() {
        $scope.construcao = CacheApp.getConstrucao();
        $scope.assinatura = true;
        $scope.descricaoObra = true;
    
        $scope.bdi =
            ($scope.construcao.BDIMaoObra == 0 && $scope.construcao.BDIMaterial == 0 && $scope.construcao.BDI > 0) ?
            ('BDI ' + $scope.construcao.BDI + '%') : 
            (
                ($scope.construcao.BDIMaoObra > 0 || $scope.construcao.BDIMaterial > 0 || $scope.construcao.BDIEquipamento > 0 || $scope.construcao.BDIServico > 0 || $scope.construcao.BDITaxa > 0) ?
                ('BDI: Material ' + $scope.construcao.BDIMaterial + '%; Equipamento '+ $scope.construcao.BDIEquipamento + '%; Mão-de-obra ' + $scope.construcao.BDIMaoObra + '%; Serviço '+ $scope.construcao.BDIServico + '%; Taxa ' + $scope.construcao.BDITaxa + '%' ) : ''
            );
    
        $scope.encargos = $scope.construcao.EncargoSocial > 0 ? ('Encargos Sociais H: ' + $scope.construcao.EncargoSocial + '%; M: '+ $scope.construcao.EncargoSocialMensal + '%') : '';
    
        $scope.getOrcamentoAnaliticoLicitacao();
    }

    $scope.loadPage();

}]);
